IrreducibleIdealDecoder Class Reference
Inheritance diagram for IrreducibleIdealDecoder:

## Public Member Functions

| IrreducibleIdealDecoder (IdealConsumer *consumer)
| ~IrreducibleIdealDecoder ()
virtual void | idealBegin (size_t varCount)
| Called before output of a monomial ideal.
virtual void | idealEnd ()
| Called after output of a monomial ideal.
virtual void | consume (mpz_ptr *exponentVector)
| For output of a generator of the ideal.
Public Member Functions inherited from Frobby::IdealConsumer
virtual | ~IdealConsumer ()
| The provided implementation does nothing.

## Private Attributes

size_t | _varCount
IdealConsumer * | _consumer
vector< mpz_ptr > | _term
mpz_class | _zero

## Detailed Description

Todo
  : This seems redundant with IdealSplitter. Investigate.

Definition at line 329 of file frobby.cpp.

## Constructor & Destructor Documentation

## IrreducibleIdealDecoder()

IrreducibleIdealDecoder::IrreducibleIdealDecoder | ( | IdealConsumer * | consumer | ) |

inline

Definition at line 331 of file frobby.cpp.

## ~IrreducibleIdealDecoder()

IrreducibleIdealDecoder::~IrreducibleIdealDecoder | ( |  | ) |

inline

Definition at line 338 of file frobby.cpp.

## Member Function Documentation

## consume()

virtual void IrreducibleIdealDecoder::consume | ( | mpz_ptr * | exponentVector | ) |

inline virtual

For output of a generator of the ideal.

exponentVector is an array containing the exponents of the generator.

The parameter exponentVector and its entries must not be altered or deallocated, and no reference to them can be retained after the consume method has returned. If the output must be stored, then a copy must be made.

Implements Frobby::IdealConsumer.

Definition at line 352 of file frobby.cpp.

## idealBegin()

virtual void IrreducibleIdealDecoder::idealBegin | ( | size_t | varCount | ) |

inline virtual

Called before output of a monomial ideal.

varCount is the number of variables of the ring within which the output ideal lies. The provided implementation does nothing.

Reimplemented from Frobby::IdealConsumer.

Definition at line 341 of file frobby.cpp.

## idealEnd()

virtual void IrreducibleIdealDecoder::idealEnd | ( |  | ) |

inline virtual

Called after output of a monomial ideal.

The provided implementation does nothing.

Reimplemented from Frobby::IdealConsumer.

Definition at line 348 of file frobby.cpp.

## Member Data Documentation

## _consumer

IdealConsumer* IrreducibleIdealDecoder::_consumer

private

Definition at line 370 of file frobby.cpp.

## _term

vector<mpz_ptr> IrreducibleIdealDecoder::_term

private

Definition at line 371 of file frobby.cpp.

## _varCount

size_t IrreducibleIdealDecoder::_varCount

private

Definition at line 369 of file frobby.cpp.

## _zero

mpz_class IrreducibleIdealDecoder::_zero

private

Definition at line 372 of file frobby.cpp.

The documentation for this class was generated from the following file:

- src/frobby.cpp